diff --git a/gnu/local.mk b/gnu/local.mk
index faad6cc6b2..7a6769fa2f 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1390,7 +1390,6 @@ dist_patch_DATA =						\
   %D%/packages/patches/libcroco-CVE-2020-12825.patch		\
   %D%/packages/patches/libcyaml-libyaml-compat.patch		\
   %D%/packages/patches/libexpected-nofetch.patch                \
-  %D%/packages/patches/libgeotiff-adapt-test-script-for-proj-6.2.patch		\
   %D%/packages/patches/libgit2-mtime-0.patch			\
   %D%/packages/patches/libgnome-encoding.patch			\
   %D%/packages/patches/libgnomeui-utf8.patch			\
diff --git a/gnu/packages/geo.scm b/gnu/packages/geo.scm
index d8e642f349..2310100c09 100644
--- a/gnu/packages/geo.scm
+++ b/gnu/packages/geo.scm
@@ -342,18 +342,14 @@ and driving.")
 (define-public libgeotiff
   (package
     (name "libgeotiff")
-    (version "1.5.1")
+    (version "1.7.1")
     (source
      (origin
        (method url-fetch)
        (uri (string-append "http://download.osgeo.org/geotiff/libgeotiff/libgeotiff-"
                            version ".tar.gz"))
-       (patches (search-patches
-                 ;; See libgeotiff 1.5.1 issue
-                 ;; https://github.com/OSGeo/libgeotiff/issues/22
-                 "libgeotiff-adapt-test-script-for-proj-6.2.patch"))
        (sha256
-        (base32 "0b31mlzcv5b1y7jdvb7p0pa3xradrg3x5g32ym911lbhq4rrgsgr"))
+        (base32 "1mjmgv48x51ppax5dnb6lq7z600czxll53bx6jbzqwd4m93i7aq5"))
        (modules '((guix build utils)))
        (snippet
         '(begin
diff --git a/gnu/packages/patches/libgeotiff-adapt-test-script-for-proj-6.2.patch b/gnu/packages/patches/libgeotiff-adapt-test-script-for-proj-6.2.patch
deleted file mode 100644
index 746610c095..0000000000
--- a/gnu/packages/patches/libgeotiff-adapt-test-script-for-proj-6.2.patch
+++ /dev/null
@@ -1,63 +0,0 @@
-From 678ffd97db2d63cf6856428bea65a93e069f812f Mon Sep 17 00:00:00 2001
-From: Even Rouault <even.rouault@spatialys.com>
-Date: Wed, 4 Sep 2019 16:11:37 +0200
-Subject: [PATCH 1/2] Adapt test script for PROJ 6.2 EPSG database (fixes #22)
-
----
- libgeotiff/test/testlistgeo          | 8 +++++++-
- libgeotiff/test/testlistgeo_out.dist | 4 ++--
- 2 files changed, 9 insertions(+), 3 deletions(-)
-
-diff --git a/libgeotiff/test/testlistgeo b/libgeotiff/test/testlistgeo
-index 7fb4a2f..571f5d0 100755
---- a/test/testlistgeo
-+++ b/test/testlistgeo
-@@ -210,10 +210,15 @@ echo "Testing listgeo equidistant_cylindrical.tif" >> ${OUT}
- $EXE ${DATA_DIR}/equidistant_cylindrical.tif >>${OUT}
- echo "" >>${OUT}
- 
-+# Normalize for results depending on the exact version of PROJ / EPSG database
-+sed "s/ETRS89-extended/ETRS89/g" < ${OUT} > ${OUT}.tmp
-+mv ${OUT}.tmp ${OUT}
-+
-+sed "s/ETRS89-extended/ETRS89/g" < ${TEST_CLI_DIR}/testlistgeo_out.dist > testlistgeo_out.dist.tmp
- 
- # do 'diff' with distribution results
- echo "diff ${OUT} with testlistgeo_out.dist"
--diff -u ${OUT} ${TEST_CLI_DIR}/testlistgeo_out.dist
-+diff -u ${OUT} testlistgeo_out.dist.tmp
- if [ $? -ne 0 ] ; then
-     echo  ""
-     echo "PROBLEMS HAVE OCCURRED"
-@@ -224,6 +229,7 @@ else
-     echo "TEST OK"
-     echo "test file ${OUT} removed"
-     echo
-+    rm testlistgeo_out.dist.tmp
-     /bin/rm -f ${OUT}
-     exit 0
- fi
-diff --git a/libgeotiff/test/testlistgeo_out.dist b/libgeotiff/test/testlistgeo_out.dist
-index 68a948c..c157f00 100644
---- a/test/testlistgeo_out.dist
-+++ b/test/testlistgeo_out.dist
-@@ -1738,11 +1738,11 @@ Geotiff_Information:
-    Keyed_Information:
-       GTModelTypeGeoKey (Short,1): ModelTypeProjected
-       GTRasterTypeGeoKey (Short,1): RasterPixelIsArea
--      ProjectedCSTypeGeoKey (Short,1): Code-3035 (ETRS89 / LAEA Europe)
-+      ProjectedCSTypeGeoKey (Short,1): Code-3035 (ETRS89-extended / LAEA Europe)
-       End_Of_Keys.
-    End_Of_Geotiff.
- 
--PCS = 3035 (ETRS89 / LAEA Europe)
-+PCS = 3035 (ETRS89-extended / LAEA Europe)
- Projection = 19986 (Europe Equal Area 2001)
- Projection Method: CT_LambertAzimEqualArea
-    ProjCenterLatGeoKey: 52.000000 ( 52d 0' 0.00"N)
-
-From 15af10648c4cb7b4c55cbe08caaf9884c1d156d9 Mon Sep 17 00:00:00 2001
-From: Even Rouault <even.rouault@spatialys.com>
-Date: Wed, 4 Sep 2019 19:13:11 +0200
-Subject: [PATCH 2/2] appveyor.yml: build vcpkg from source to fix issue with
- VS2015