diff --git a/gnu/local.mk b/gnu/local.mk
index 0c4edf6e56..3bc947f30c 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1774,6 +1774,7 @@ dist_patch_DATA =						\
   %D%/packages/patches/rocm-comgr-3.1.0-dependencies.patch \
   %D%/packages/patches/rocm-opencl-runtime-4.3-noclinfo.patch \
   %D%/packages/patches/rocm-opencl-runtime-4.3-noopencl.patch \
+  %D%/packages/patches/ruby-latex-decode-fix-test.patch		\
   %D%/packages/patches/ruby-mustache-1.1.1-fix-race-condition-tests.patch \
   %D%/packages/patches/ruby-sanitize-system-libxml.patch	\
   %D%/packages/patches/rustc-1.39.0-src.patch			\
diff --git a/gnu/packages/patches/ruby-latex-decode-fix-test.patch b/gnu/packages/patches/ruby-latex-decode-fix-test.patch
new file mode 100644
index 0000000000..58d7d16258
--- /dev/null
+++ b/gnu/packages/patches/ruby-latex-decode-fix-test.patch
@@ -0,0 +1,66 @@
+From 698e39a251d433e2cd2934586a2dfc5e6582c4f9 Mon Sep 17 00:00:00 2001
+From: Philip McGrath <philip@philipmcgrath.com>
+Date: Sun, 24 Jul 2022 09:12:55 -0400
+Subject: [PATCH] Improve readability of whitespace tests
+
+This change fixes the test for `~x` in some environments in which it
+was previously failing.
+
+Related to https://github.com/inukshuk/latex-decode/issues/13
+---
+ features/step_definitions/latex.rb |  5 +++++
+ features/symbols.feature           |  7 -------
+ features/whitespace.feature        | 13 +++++++++++++
+ 3 files changed, 18 insertions(+), 7 deletions(-)
+ create mode 100644 features/whitespace.feature
+
+diff --git a/features/step_definitions/latex.rb b/features/step_definitions/latex.rb
+index 4b1b595..fca63c0 100644
+--- a/features/step_definitions/latex.rb
++++ b/features/step_definitions/latex.rb
+@@ -5,3 +5,8 @@ end
+ Then /^the result should be ('|")(.*)\1$/ do |quote,value|
+   expect(@result).to eq(value)
+ end
++
++# For whitespace or other characters that are hard to read in source code:
++Then /^I should get '([^']*)' \+ U\+(\h{4,}) \+ '([^']*)'$/ do |pre,code,post|
++  expect(@result).to eq(pre + code.hex.chr(Encoding::UTF_8) + post)
++end
+diff --git a/features/symbols.feature b/features/symbols.feature
+index 46d9a51..f8a5e84 100644
+--- a/features/symbols.feature
++++ b/features/symbols.feature
+@@ -12,10 +12,3 @@ Feature: Decode LaTeX symbol directives
+     | \\uparrow            | ↑       |
+     | \\downarrow          | ↓       |
+     | \\rightarrow         | →       |
+-
+-  Scenarios: Whitespace
+-    | latex | unicode | description        |
+-    | x\\,x | x x     | small space        |
+-    | x~x   | x x     | non-breaking space |
+-    | ~x    |  x      | non-breaking space |
+-
+diff --git a/features/whitespace.feature b/features/whitespace.feature
+new file mode 100644
+index 0000000..fe5b208
+--- /dev/null
++++ b/features/whitespace.feature
+@@ -0,0 +1,13 @@
++Feature: Decode LaTeX whitespace directives
++  As a hacker who works with LaTeX
++  I want to be able to decode LaTeX whitespace
++
++  Scenario Outline: LaTeX to Unicode transformation
++    When I decode the string '<latex>'
++    Then I should get <pre> + U+<code> + <post>
++
++  Scenarios: Whitespace
++    | latex | pre | code | post | description                |
++    | x~x   | 'x' | 00A0 | 'x'  | non-breaking space         |
++    | ~y    | ''  | 00A0 | 'y'  | leading non-breaking space |
++    | z\\,z | 'z' | 2009 | 'z'  | small space                |
+-- 
+2.32.0
+
diff --git a/gnu/packages/ruby.scm b/gnu/packages/ruby.scm
index 746bb9b6ce..fb9d5c53b9 100644
--- a/gnu/packages/ruby.scm
+++ b/gnu/packages/ruby.scm
@@ -13111,3 +13111,53 @@ (define-public ruby-ritex
 into HTML pages easy.  It supports most TeX math syntax as well as macros.")
     ;; doesn't clearly state -only vs -or-later
     (license license:gpl2)))
+
+(define-public ruby-latex-decode
+  (let ((commit "08cc2d4a2c1359abaeb2f1e1a9d78e16a546cf7c")
+        (revision "1"))
+    ;; The commit is a released version, but doesn't have a Git tag.
+    ;; Using Git rather than the gem makes it easier to patch.
+    (package
+      (name "ruby-latex-decode")
+      (version (git-version "0.3.2" revision commit))
+      (source (origin
+                (method git-fetch)
+                (uri (git-reference
+                      (url "https://github.com/inukshuk/latex-decode")
+                      (commit commit)))
+                (sha256
+                 (base32
+                  "0clvnqms81i33iff3pr3zz8sbyknvg704zghd62ysqrlbi4jpcpk"))
+                (patches
+                 ;; see https://github.com/inukshuk/latex-decode/issues/13
+                 (search-patches "ruby-latex-decode-fix-test.patch"))
+                (file-name (git-file-name name version))))
+      (build-system ruby-build-system)
+      (native-inputs
+       (list ruby-byebug
+             ruby-cucumber
+             ruby-ritex
+             ruby-rspec))
+      (arguments
+       (list
+        #:test-target "cucumber"
+        #:phases
+        #~(modify-phases %standard-phases
+            (add-after 'extract-gemspec 'less-strict-dependencies
+              (lambda args
+                (substitute* "Gemfile"
+                  (("'cucumber', '[^']*'")
+                   "'cucumber'"))))
+            (add-after 'replace-git-ls-files 'replace-another-git-ls-files
+              (lambda args
+                (substitute* "latex-decode.gemspec"
+                  (("`git ls-files -- [{]test,spec,features[}]/\\*`")
+                   "`find {test,spec,features} -type f | sort`")))))))
+      (home-page "https://github.com/inukshuk/latex-decode")
+      (synopsis "Convert LaTeX to Unicode")
+      (description
+       "This package provides a gem to convert LaTeX input to Unicode.  Its
+original use was as an input filter for BibTeX-Ruby, but it can be used
+independently to decode LaTeX.  Many of the patterns used by this Ruby gem are
+based on François Charette's equivalent Perl module @code{LaTeX::Decode}.")
+      (license license:gpl3+))))